//Do not edit! This file was generated by Unity-ROS MessageGeneration.
using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using Unity.Robotics.ROSTCPConnector.MessageGeneration;

namespace RosMessageTypes.HlrcServer
{
    [Serializable]
    public class UtteranceMsg : Message
    {
        public const string k_RosMessageName = "hlrc_server/Utterance";
        public override string RosMessageName => k_RosMessageName;

        // list of symbol/duration pairs
        public PhonemeMsg[] phonemes;
        // sound data (raw data, similar to a wave file)
        public SoundchunkMsg audio;
        // textual description
        public string text;

        public UtteranceMsg()
        {
            this.phonemes = new PhonemeMsg[0];
            this.audio = new SoundchunkMsg();
            this.text = "";
        }

        public UtteranceMsg(PhonemeMsg[] phonemes, SoundchunkMsg audio, string text)
        {
            this.phonemes = phonemes;
            this.audio = audio;
            this.text = text;
        }

        public static UtteranceMsg Deserialize(MessageDeserializer deserializer) => new UtteranceMsg(deserializer);

        private UtteranceMsg(MessageDeserializer deserializer)
        {
            deserializer.Read(out this.phonemes, PhonemeMsg.Deserialize, deserializer.ReadLength());
            this.audio = SoundchunkMsg.Deserialize(deserializer);
            deserializer.Read(out this.text);
        }

        public override void SerializeTo(MessageSerializer serializer)
        {
            serializer.WriteLength(this.phonemes);
            serializer.Write(this.phonemes);
            serializer.Write(this.audio);
            serializer.Write(this.text);
        }

        public override string ToString()
        {
            return "UtteranceMsg: " +
            "\nphonemes: " + System.String.Join(", ", phonemes.ToList()) +
            "\naudio: " + audio.ToString() +
            "\ntext: " + text.ToString();
        }

#if UNITY_EDITOR
        [UnityEditor.InitializeOnLoadMethod]
#else
        [UnityEngine.RuntimeInitializeOnLoadMethod]
#endif
        public static void Register()
        {
            MessageRegistry.Register(k_RosMessageName, Deserialize);
        }
    }
}
